%%% This file is part of RefactorErl.
%%%
%%% RefactorErl is free software: you can redistribute it and/or modify
%%% it under the terms of the GNU Lesser General Public License as published
%%% by the Free Software Foundation, either version 3 of the License, or
%%% (at your option) any later version.
%%%
%%% RefactorErl is distributed in the hope that it will be useful,
%%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%%% GNU Lesser General Public License for more details.
%%%
%%% You should have received a copy of the GNU Lesser General Public License
%%% along with RefactorErl.  If not, see <http://plc.inf.elte.hu/erlang/>.
%%%
%%% The Original Code is RefactorErl.
%%%
%%% The Initial Developer of the Original Code is Eötvös Loránd University.
%%% Portions created  by Eötvös Loránd University and ELTE-Soft Ltd.
%%% are Copyright 2007-2025 Eötvös Loránd University, ELTE-Soft Ltd.
%%% and Ericsson Hungary. All Rights Reserved.

-module(reftest_refcore_form_cache).
-include("test.hrl").
-include_lib("eunit/include/eunit.hrl").

compare(Node) ->  
    A = refcore_syntax:flat_text(Node),
    ?d(A),
    B = refcore_syntax:flat_text_legacy(Node),
    ?d(B),
    A == B.

cache_basic_compare_test() ->
    ri:add("../test/unit_tests/form_cache/hello.erl"),
    ?assert(compare({'$gn', root, 0})),
    ?assert(compare({'$gn', file, 1})),
    Forms = ?Graph:path({'$gn',file,1},[form]),
    [?assert(compare(Form)) || Form <- Forms],
    ?assert(compare({'$gn', clause, 1})),
    ?assert(compare({'$gn', expr, 24})),
    ri:clean().
